[LeetCode] 154. Find Minimum in Rotated Sorted Array II_Hard tag: not real binary search anymore

Suppose an array sorted in ascending order is rotated at some pivot unknown to you beforehand.

(i.e.,  [0,1,2,4,5,6,7] might become  [4,5,6,7,0,1,2]).

Find the minimum element.

The array may contain duplicates.

Example 1:

Input: [1,3,5]
Output: 1

Example 2:

Input: [2,2,2,0,1]
Output: 0

Note:

这题是[LeetCode] 153. Find Minimum in Rotated Sorted Array_Medium tag: Binary Search的follow up,允许重复,但是如果重复数量太多,比如[2,2,2,2,2,2,2,0,2,2,2,2] 时间复杂度可能会上升到O(n), 而且二分法不再实用,所以直接用暴力破解就好。

Code

class Solution:
    def findMinRotate(self, nums):
        ans = nums[0]
        for num in nums:
            ans = min(ans, num)
        return ans

 

转载于:https://www.cnblogs.com/Johnsonxiong/p/11168353.html

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值